package com.sogou.flutter.sg_video_player;

import android.content.Context;
import android.util.Log;

import com.google.android.exoplayer2.SimpleExoPlayer;

import java.util.Map;

import io.flutter.plugin.common.EventChannel;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.view.TextureRegistry;

import static android.content.ContentValues.TAG;
import static com.google.android.exoplayer2.Player.REPEAT_MODE_ALL;
import static com.google.android.exoplayer2.Player.REPEAT_MODE_OFF;

public class VideoPlayer {

    private SimpleExoPlayer exoPlayer;

    public VideoPlayer(Context context, EventChannel eventChannel, TextureRegistry.SurfaceTextureEntry handle, MethodChannel.Result result) {
    }

    public  Long getPosition(){
        return exoPlayer.getCurrentPosition();
    }

    public void play() {
        exoPlayer.setPlayWhenReady(true);
        sendPlayed();
    }

    public void pause() {
        exoPlayer.setPlayWhenReady(false);
        sendPaused();
    }

    public void setLooping(Boolean value) {
        exoPlayer.setRepeatMode( value? REPEAT_MODE_ALL : REPEAT_MODE_OFF);
    }

    public void setVolume(Double value) {
        float bracketedValue = (float) Math.max(0.0, Math.min(1.0, value));
        exoPlayer.setVolume(bracketedValue);
    }

    public void seekTo(Long location) {
        exoPlayer.seekTo(location);
    }

    public void stop() {
        exoPlayer.stop(true);
        sendStoped();
    }

    private void sendPlayed() {
//        Log.e(TAG, "$id -> sendPlayed");
//        Map event = new HashMap<String, Any>();
//        event["event"] = "playing";
//        eventSink.success(event);
    }

    private void sendPaused() {
        Log.e(TAG, "$id -> sendPaused");
//        val event = HashMap<String, Any>()
//        event["event"] = "paused"
//        eventSink.success(event)
    }

    private void sendStoped() {
        Log.e(TAG, "$id -> sendStoped");
//        val event = HashMap<String, Any>()
//        event["event"] = "created"
//        eventSink.success(event)
    }

    public void dispose() {
    }

    public void sendBufferingUpdate() {
    }

    public void resetToNewDatasource(String newDataSource, Boolean autoPlay, long textureId) {
    }
}
